package org.jvisu.base;

/** Interface for JVisu base library members
 *
 *  <p>$Id: JVBaseMembers.java,v 1.4 2004/04/19 08:20:55 tgl Exp $
 *  </p>
 *  <p>Copyright 2003 Thomas Gleixner <tglx@linutronix.de></p>
 *
 *  <p>This program is free software; you can redistribute it and/or modify
 *  it under the terms of the GNU General Public License version 2 as
 *  published by the Free Software Foundation. See file LICENCE in this
 *  directory</p>
 *  
 *  <p>Change Log:</p>
 *  <ul>
 *  <li> 1.0 Initial inmplimentation </li>
 *  </ul>
 *  <p>
 *  <p>Interface declaration for JVisu Base members
 *  </p>
 *
 * @author Thomas Gleixner <tglx@linutronix.de>
 * @version 1.0 
*/
public interface JVBaseMembers {
    
    /** Return the design position of this component
     * @return designposition
     */
    public abstract java.awt.Point getDesignpos();
    
    /** Set the design position of this component
     * @param newpos new designposition
     */
    public abstract void setDesignpos(java.awt.Point newpos);

    /** Return the design size of this component
     * @return design size
     */
    public abstract java.awt.Dimension getDesignsize();
    
    /** Set the design size of this component
     * @param newpos new designsize
     */
    public abstract void setDesignsize(java.awt.Dimension newdim);

    /** Get the zoom factor of this component
     * @return zoomfactor for this component
     */
    public abstract double getZoomfactor();

    /** Set the zoom factor of this component
     * @param zoom new zoomfactor for this component
     */
    public abstract void setZoomfactor(double zoom);
    
    /** Get the design model of this component. This
     *  model is used to identify the constraints of the component in
     *  the deisgner
     * @return the designmodel string
     */
    public abstract String getDesignModel();
    
    /** Set the design model of this component. This
     *  model is used to identify the constraints of the component in
     *  the deisgner
     * @param model the designmodel string
     */
    public abstract void setDesignModel(String model);
    
    /** Get the ability of this component to have subcomponents
     * @return true, if subcomponents are allowed
     */
    public abstract boolean isContainer();
}
