package org.jvisu.panel.configurator.editors;

import java.awt.*;
import java.beans.*;
import org.jvisu.comm.*;

/**
 *  <p>package:    JVisu</p>
 *  <p>file:       JVSubPanel.java</p>
 * $Id: JVCommType.java,v 1.1 2003/11/19 10:37:43 tgl Exp $
 *
 *  <p>Copyright 2003 Thomas Gleixner <tglx@linutronix.de></p>
 *
 * <p>This program is free software; you can redistribute it and/or modify
 *  it under the terms of the GNU General Public License version 2 as
 *  published by the Free Software Foundation.</p>
 * </p>
 *
 * Change Log:
 * </p>
 * <ul>
 * <li> 1.0 First implementation
 * </ul>
 * <p>
 * </p>
 * Customized editor for JVComm selections
 *
 * @author Thomas Gleixner <tglx@linutronix.de>
 * @version 1.3
 */
public class JVCommType extends PropertyEditorSupport {
    
    /** The tag array for the combobox*/
    private String[][]    commtypes;
    
    /** Creates a new instance of JVCommType */
    public JVCommType(Object source) {
        super(source);
        commtypes = JVComm.getCommTypes();
    }

    /** provide the tags for this property
     *  @return String array for combobox creation
    */
    public final String[] getTags() {
        String[] types = new String[commtypes.length];
        for (int i = 0; i < commtypes.length; i++)
            types[i] = commtypes[i][1];
        return types;
    }

    /** Get the value as text
     * @return text for the selection
     */
    public String getAsText() {
        String txt = super.getAsText();
        for (int i = 0; i < commtypes.length; i++) {
            if (commtypes[i][0].equals(txt))
                return commtypes[i][1];
        }
        return null;
    }

    /** Set the value as text
     * @param txt text for the selection
     */
    public void setAsText(String txt) {
        for (int i = 0; i < commtypes.length; i++) {
            if (commtypes[i][1].equals(txt))
                super.setAsText(commtypes[i][0]);
        }
    }
}
